/*
 * Copyright (C) 2007 Andre Noll <maan@tuebingen.mpg.de>
 *
 * Licensed under the GPL v2. For licencing details see COPYING.
 */

/** \file signal.h exported symbols from signal.c */

/**
 * Task for signal handling.
 */
struct signal_task {
	/** The signal pipe. */
	int fd;
	/** The associated task structure. */
	struct task *task;
};

_static_inline_ void signal_pre_select(struct sched *s, void *context)
{
	struct signal_task *st = context;
	para_fd_set(st->fd, &s->rfds, &s->max_fileno);
}

struct signal_task *signal_init_or_die(void);
void para_sigaction(int sig, void (*handler)(int));
void para_install_sighandler(int);
int para_reap_child(pid_t *pid);
int para_next_signal(fd_set *rfds);
void signal_shutdown(struct signal_task *st);
void para_block_signal(int sig);
void para_unblock_signal(int sig);
